/*
    libtree : C++ lib that helps to work with tree-like data structures
    Copyright (C) 2019-2024 Alexey Appolonov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef     ltree_jsonH
#define     ltree_jsonH

#include    "tree.h"
#include    <json/json.h>

namespace tree{

//-----------------------------------------------------------------------------
// XML-interface

class TJsonTree : public TTree{

    private:

        int Type(void) const{
            return TYPE_JSON;
            }

        bool GetValues(const int branches_q, const Json::Value &current_node,
                vector<TNode> &subtree, TSelectedValues &selected_values,
                TSelectedDataEntry &entry, int level=-1, int abs_level=-1,
                const int array_el=-1);

        bool SpecialPartOFSelect(const string &file_path,
                vector<TNode> &subtree, TSelectedValues &selected_values,
                TSelectedDataEntry& entry, string &err);
    };

//----------------------------------------------------------------------

} // namespace tree

#endif
